#include "component.h"
#include "exportdefinitions.h"
#include "objectfile.h"
#include "sourcepackage.h"

using namespace std;
using namespace Msp;

ExportDefinitions::ExportDefinitions(Builder &b, const Component &c, const list<ObjectFile *> &objs):
	FileTarget(b, c.get_package(), generate_target_path(c))
{
	component = &c;
	for(list<ObjectFile *>::const_iterator i=objs.begin(); i!=objs.end(); ++i)
		add_dependency(**i);
}

FS::Path ExportDefinitions::generate_target_path(const Component &comp)
{
	return comp.get_package().get_temp_directory()/comp.get_name()/(comp.get_name()+".def");
}
